#!/usr/bin/perl

################################################################
# Script/Program to insert a comment into an Oracle table      #
# or column from a browser web page. The script builds the     #
# input form, then submits the comment.                        #
# (c)1996 Costello/Feynman Memorial Labs. All rights reserved. #
# Real (c)1996 scott beimer.                                   #
# author makes no warranties as to fitness or merchantability  #
# of the code. use at your own risk.                           #
################################################################

use Oci;
package Oci;
require "ociwrap.pl";

$date = `date +"%A, %B %d, %Y at %T (%Z)"`; chop($date);

$host = $ENV{'REMOTE_HOST'};
$host =~ s/\W.*//;
$dateline = "Requested by $host on $date\n";
$con_len = $ENV{'CONTENT_LENGTH'};
$agent = $ENV{'HTTP_USER_AGENT'};

if ($con_len == 0) {
     &GET_COMMENT;
} else {
     read(STDIN, $buffer, $con_len);
     @pairs = split(/&/, $buffer);
     foreach $pair (@pairs) {
          ($field, $value) = split(/=/, $pair);
          $value =~ tr/+/ /;
          $value =~ s/%([a-fA-F0-9][a-fA-F0-9])/pack("C", hex($1))/eg;
          $value =~ s/<!--(.|\n)*-->//g;
          $value =~ s/<([^>]|\n)*>//g;
          $FORM{$field}=$value;
     }
     $owner = $FORM{owner};
     $passwd = $FORM{passwd};
     $connect = $FORM{connect};
     $tabname = $FORM{tabname};
     $colname = $FORM{colname};
     $comment = $FORM{comment};
     $MAX = 80;
     $comment =~ s/.{1,$MAX}\s/$&\n/g;
     &PUT_COMMENT;
}

sub GET_COMMENT {
     print "Content-type: text/html\n\n";
     print "<html><head><title>Oracle...</title></head><body>\n";
     print "<form method=\"post\" action=\"comment.cgi\">\n";
     print "Enter the Oracle login information for the owner of the table or column you wish to comment.<p>\n";
     print "<pre>Owner name:     <input type=\"text\" name=\"owner\">\n";
     print "Password:       <input type=\"password\" name=\"passwd\">\n";
     print "Connect String: <input type=\"text\" name=\"connect\"></pre><hr>\n";
     print "To insert a TABLE comment, enter just the table name below, leave the column name empty.\n";
     print "To insert a COLUMN comment, enter the table AND column names. To remove a comment, enter the name(s) and leave the comment field empty.<p>\n";
     print "<pre>Table Name:  <input name=\"tabname\" type=\"text\">\n";
     print "Column Name: <input name=\"colname\" type=\"text\">\n";
     print "Comment:     <input name=\"comment\" type=\"text\" size=\"50\" maxlength=\"2000\">\n\n";
     print "<input type=\"submit\" value=\"Insert Comment\">   <input type=\"reset\" value=\"Clear Form\">\n";
     print "</form></pre></body></html>\n";
}

sub PUT_COMMENT {
     print "Content-type: text/html\n\n";
     print "<html><head><title>Response</title></head><body>\n";
     if ($colname) {
          $sql = "comment on column $tabname.$colname is '$comment'";
     } else {
          $sql = "comment on table $tabname is '$comment'";
     }
     ckconnect("$owner/$passwd\@$connect");
     ($status, $ins_comment) = oracursor($sql);
     if ($status == 0) {
          print "<h1>314 System error</h1>\n";
          print "<h3>An error has been returned by the system.</h3>\n";
          print "<h3>You said:</h3>\n";
          print "<tt>$sql</tt>\n";
          print "<h3>and Oracle replied:</h3>\n";
          print "<tt>$oermsg<p></tt>\n";
     } else {
          ckopen($ins_comment);
          ckclose($ins_comment);
          ckdisconnect();
          print "<form method=\"post\" action=\"comment.cgi\">\n";
          print "Oracle login information\n";
          print "\n";
          print "<pre>Owner name:     <input type=\"text\" name=\"owner\" value=\"$owner\">\n";
          print "Password:       <input type=\"password\" name=\"passwd\" value=\"$passwd\">\n";
          print "Connect String: <input type=\"text\" name=\"connect\" value=\"$connect\"></pre><hr>\n";
          if ($colname) { $comtype = 'column'; } else { $comtype = 'table';}
          print "<h2>Your $comtype comment has been inserted</h2>";
          print "<pre>Table Name:  <input name=\"tabname\" type=\"text\">\n";
          print "Column Name: <input name=\"colname\" type=\"text\">\n";
          print "Comment:     <input name=\"comment\" type=\"text\" size=\"50\" maxlength=\"2000\">\n\n";
          print "<input type=\"submit\" value=\"Insert Comment\">   <input type=\"reset\" value=\"Clear Form\">\n";
          print "</form></pre></body></html>\n";
     }
}
